
import java.util.Objects;

class Dog {
	private String name;
	private int weight; // pounds

	public Dog(String nm, int w) {
		this.name = nm;
		this.weight = w;
	}

	public String toString() {
		return String.format("%s (%d pounds)", this.name, this.weight); 
	}

	public int getWeight() {
		return this.weight;
	}

	public String getName() {
		return this.name;
	}

	public String setName(String nm) {
		return this.name = nm;
	}

	@Override
	public boolean equals(Object o) {
		// NOTE WELL -- we are only comparing name (not weight) by our design decision
		if (o == this)
			return true;
		if (!(o instanceof Dog))
			return false;
		Dog dog = (Dog) o;
		return Objects.equals(this.getName(), dog.getName());
	}

	@Override
	public int hashCode() {
		return Objects.hash(this.getName());
	}

}
