
import java.util.ArrayList;
import java.util.Arrays;
import static java.lang.System.out;

public class ListLab1 {

	public static void main(String[] args) {
		ListLab1 lab = new ListLab1();
		lab.simpleInitializeAndPrint();
		lab.basicListOps();
		lab.computeTotalDogWeight();
		lab.removingDogs();
	}

	public void simpleInitializeAndPrint() {
		// Declare and initialize
		out.println("\n--simpleInitializeAndPrint()");

		// Here we construct a list of Dogs.
		ArrayList<Dog> dogs = new ArrayList<>();

		// Add Dog objects to list
		dogs.add(new Dog("FooFoo", 12));
		dogs.add(new Dog("Doggy", 9));
		dogs.add(new Dog("Ruffy", 2));
		dogs.add(new Dog("Buzzles", 5));

		// Print the list (print helper is a bit verbose yes -- toString...toArray)
		out.println("Dogs: " + dogs.toString());
	}

	public void basicListOps() {
		out.println("\n--basicListOps()");
		ArrayList<Dog> dogs = sampleDogsList1();
		out.println("Dogs: " + Arrays.toString(dogs.toArray()));

		// Show size of list
		out.println("Dogs size (# of elements): " + dogs.size());

		// Get a Dog from the list
		Dog d = dogs.get(1);

		out.println("Dog at index pos 1 (2nd Dog): " + d.toString());
	}

	public void computeTotalDogWeight() {
		out.println("\n--computeTotalDogWeight()");
		ArrayList<Dog> dogs = sampleDogsList1();
		int totalWeight = 0;

		// Iterate over a list, accumulating total weight as we go
		// ArrayList iteratin syntax is nice and simple -- (<Type> <varName>:
		// <listVarName>)
		for (Dog eachDog : dogs)
			totalWeight += eachDog.getWeight();

		out.println("Dogs: " + Arrays.toString(dogs.toArray()));
		out.println("Total Weight: " + totalWeight);
	}

	public void removingDogs() {
		out.println("\n--removingDogs()");
		ArrayList<Dog> dogs = sampleDogsList1();
		out.println("Dogs (Initial): " + Arrays.toString(dogs.toArray()));

		// Remove dog from list at index 0 (1st element)
		dogs.remove(0);

		// Remove dog from list at index size-1 (last element)
		dogs.remove(dogs.size() - 1);

		out.println("Dogs (after removing first and last): " + Arrays.toString(dogs.toArray()));

		// Remove all from list
		dogs.clear();

		out.println("Dogs (after removing all): " + Arrays.toString(dogs.toArray()));
	}

	public static ArrayList<Dog> sampleDogsList1() {
		// I'm a helper method. I simply return a list of nice dogs.
		ArrayList<Dog> dogs = new ArrayList<>();
		dogs.add(new Dog("FooFoo", 12));
		dogs.add(new Dog("Doggy", 9));
		dogs.add(new Dog("Ruffy", 2));
		dogs.add(new Dog("Buzzles", 5));
		return dogs;
	}

}
