
import static java.lang.System.out;
import java.util.ArrayList;

public class ListLab2 {
	
	//--------------------------------------------------------
	//Program Driver	
	
	public static void main(String[] args) {
		ListLab2 lab = new ListLab2();
		lab.demoCheckingIfListContainsElement();
		lab.demoUnion();
		lab.demoIntersection();
		lab.demoFindingSmallestDog();
		lab.demoSelectingSubset();		
	}	
	
	//--------------------------------------------------------
	//Demoing	

	public void demoCheckingIfListContainsElement() {
		// NOTE WELL -- implement equals() and hashCode() in the list element class
		// (e.g. see our Dog methods)
		out.println("\n--Demo doesListContain()");
		ArrayList<Dog> dogs = sampleDogsList1();
		out.println("Dogs: " + dogs.toString());

		// Check if the list contains Dog named "Ruffy"
		Dog myDog = new Dog("Ruffy", 2);		
		out.printf("List of dogs contains [%s]: %s%n", "Ruffy", dogs.contains(myDog));

		// Check if the list contains Dog named "Pugs"
		myDog = new Dog("Pugs", 41);		
		out.printf("List of dogs contains [%s]: %s%n", "Pugs", dogs.contains(myDog));		
	}

	public void demoUnion() {
		out.println("\n--Demo union()");
		ArrayList<Dog> dogs1 = sampleDogsList2();
		ArrayList<Dog> dogs2 = sampleDogsList3();
		out.println("Dogs ArrayList 1: " + dogs1.toString());
		out.println("Dogs ArrayList 2: " + dogs2.toString());

		// Build a list that contains all of the elements of the two other lists (union)
		ArrayList<Dog> allDogs = new ArrayList<>();
		allDogs.addAll(dogs1);
		allDogs.addAll(dogs2);

		out.println("All Dogs (union of lists -- duplicates allowed): " + allDogs.toString());
	}

	public void demoIntersection() {
		out.println("\n--Demo intersection()");
		ArrayList<Dog> dogs1 = sampleDogsList2();
		ArrayList<Dog> dogs2 = sampleDogsList3();
		out.println("Dogs ArrayList 1: " + dogs1.toString());
		out.println("Dogs ArrayList 2: " + dogs2.toString());
		ArrayList<Dog> newList = new ArrayList<>();
		newList.addAll(dogs1);

		// The 'retainAll()' method effectively does
		// an "intersection" of newList with "dogs2"
		newList.retainAll(dogs2);

		out.println("Intersecting Dogs (in both lists): " + newList.toString());
	}
	
	public void demoFindingSmallestDog() {
		out.println("\n--Demo finding smallest dog");
		ArrayList<Dog> dogs;
		
		dogs = sampleDogsList1();
		out.println("Dogs: " + dogs.toString());		
		out.println("Smallest Dog: " + this.findSmallestIn(dogs));		
		
		dogs = sampleDogsList2();
		out.println("Dogs: " + dogs.toString());		
		out.println("Smallest Dog: " + this.findSmallestIn(dogs));		
	}
	
	public void demoSelectingSubset() {
		out.println("\n--Demo Selecting Subset");
		ArrayList<Dog> dogs = sampleDogsList4();
		ArrayList<Dog> result;		

		out.println("Dogs: " + dogs.toString());
		result = this.selectSmallDogsIn(dogs, 3);
		out.printf("All Small Dogs (Three Pounds or Less): %s%n%n", result.toString()); 
		
		out.println("Dogs: " + dogs.toString());
		result = this.selectSmallDogsIn(dogs, 2);
		out.printf("All Tiny-Tiny Dogs (Two Pounds or Less): %s%n%n", result.toString());
		
		out.println("Dogs: " + dogs.toString());
		result = this.selectDogsNamed(dogs, "Pal");
		out.printf("All Dogs named [Pal]: %s", result.toString());
	}	
	
	//--------------------------------------------------------
	//Helpers
		
	public Dog findSmallestIn(ArrayList<Dog> dogs) {
		//Helper method that returns the smallest dog in list of dogs,
		//Get rid of easy special case first
		//Special Case: If no dogs, return null 
		if (dogs.isEmpty()) {
			return null;
		}
		//Special Case: List size of one, we know then the one and only is smallest
		if (dogs.size() == 1) {
			return dogs.get(0);		//first dog is at index 0 (Java uses 0-based lists)
		}
		//Finally let's loop, we know we have at least two dogs
		Dog smallest = dogs.get(0);
		//Start loop at i=1 (skip over i=0, which we've already grabbed as initial 'smallest'
		for (int i=1; i<dogs.size(); i++) {
			Dog nextDog = dogs.get(i);
			if (nextDog.getWeight() < smallest.getWeight()) {
				smallest = nextDog;
			}
		}
		return smallest;
	}
	
	public ArrayList<Dog> selectSmallDogsIn(ArrayList<Dog> dogs, int maxWeight) {
		//Select (and return) all dogs less than or equal to <maxWeight>
		ArrayList<Dog> selectedDogs = new ArrayList<>();
		
		for (Dog nextDog: dogs) {
			if (nextDog.getWeight() <= maxWeight) {
				selectedDogs.add(nextDog);
			}
		}
		return selectedDogs;
	}
	
	public ArrayList<Dog> selectDogsNamed(ArrayList<Dog> dogs, String name) {
		//Select (and return) all dogs that have name equal to parameter <name>
		ArrayList<Dog> selectedDogs = new ArrayList<>();
		
		for (Dog nextDog: dogs) {
			if (nextDog.getName().equals(name)) {
				selectedDogs.add(nextDog);
			}
		}
		return selectedDogs;
	}	

	//-----------------------------------------------------
	//Sample Data Supplyers
	
	public static ArrayList<Dog> sampleDogsList1()
	{
 		ArrayList<Dog> dogs = new ArrayList<>();
     	dogs.add(new Dog("FooFoo", 12));
      	dogs.add(new Dog("Doggy", 9));
 	    dogs.add(new Dog("Ruffy", 2));
      	dogs.add(new Dog("Buzzles", 5));
      	return dogs;
	}	

	public static ArrayList<Dog> sampleDogsList2() {
		ArrayList<Dog> dogs = new ArrayList<>();
		dogs.add(new Dog("Sweetie", 9));
		dogs.add(new Dog("Jax", 2));
		return dogs;
	}

	public static ArrayList<Dog> sampleDogsList3() {
		ArrayList<Dog> dogs = new ArrayList<>();
		dogs.add(new Dog("Pal", 9));
		dogs.add(new Dog("Sweetie", 2));
		dogs.add(new Dog("Pepper", 2));
		return dogs;
	}
	
	public static ArrayList<Dog> sampleDogsList4() {
		ArrayList<Dog> dogs = new ArrayList<>();
		dogs.add(new Dog("Pal", 5));			//Small dog named "Pal"
		dogs.add(new Dog("Sweetie", 3));
		dogs.add(new Dog("Pepper", 3));
		dogs.add(new Dog("Pal", 80));			//Big dog named "Pal"		
		return dogs;
	}	

}
